# Author: Emalayan
# Date: 16 March 2012
# Description: This swift script represents the pipeline pattern
# TODO (Emalayan & Lauro) Measuring stage in/out time and workflow time 
# separately.

type file;
# File sizes in KB

# TODO(emalayan) pass these values as command line parameters
int intermediateFileSize=20480;
int finalFileSize=1024;

# If n is not specified in the swift command line then pipeline.swift will 
# execute with the default value of n = 10.
string jobCount="10";

# Function declarations
app (file outputFile) create_file (int size){
    writeperf size @outputFile;
}

app read_file (file input){
    readperf @input;
}

app (file outputFile) stage_out (file final){
    copy @final @outputFile;
}

app (file outputFile) stage_in (file inputfile){
    copy @inputfile @outputFile;
}

# File data-type declaration
file data<"data_files/data.txt">;

# Anonymous file type
file input_data[];
file stage_1_output[];
file stage_2_output[];
file stage_3_output[]; 
file final_output[]<simple_mapper; location="final", prefix="pipeline_final.",suffix=".out">;

# Workflow starts here with data-stage-in 
foreach j in [1:@toint(@arg("n",jobCount))]{
    input_data[j] = stage_in(data);
}

# Stage-1 read the input
foreach j in [1:@toint(@arg("n",jobCount))]{
    read_file(input_data[j]);
}

# Stage-1 produce the output
foreach j in [1:@toint(@arg("n", jobCount))]{
    stage_1_output[j] = create_file(intermediateFileSize);
}

# Stage-2 read the input 
foreach j in [1:@toint(@arg("n",jobCount))]{
    read_file(stage_1_output[j]);
}

# Stage-2 produce the output
foreach j in [1:@toint(@arg("n", jobCount))]{
    stage_2_output[j] = create_file(intermediateFileSize);
}

# Stage-3 read the input
foreach j in [1:@toint(@arg("n", jobCount))]{
    read_file(stage_2_output[j]);
}

# Stage-3 produce the output
foreach j in [1:@toint(@arg("n", jobCount))]{
    stage_3_output[j] = create_file(finalFileSize);
}

# Workflow ends here with stageing-out the data
foreach j in [1:@toint(@arg("n", jobCount))]{
    final_output[j] = stage_out(stage_3_output[j]);
}

